## mingw-w64-seacas-2025.03.13-2.src.tar.zst

=== CMakeLists.txt ===
#
# A) Define your project name and set up major project options
#

# Must set the project name as a variable at very beginning before including anything else
# We set the project name in a separate file so CTest scripts can use it.
INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/ProjectName.cmake)

SET(Seacas_ENABLE_Zoltan_DEFAULT ON)
SET(TRIBITS_HIDE_DEPRECATED_INCLUDE_DIRECTORIES_OVERRIDE TRUE)

# Define the TriBITS minimum required CMake version
SET(TRIBITS_CMAKE_MINIMUM_REQUIRED 3.22.0)

# CMake requires this be in the top file and not in an include file :-(
CMAKE_MINIMUM_REQUIRED(VERSION ${TRIBITS_CMAKE_MINIMUM_REQUIRED} FATAL_ERROR)

# CMake requires that you declare the CMake project in the top-level file and
# not in an include file :-(
PROJECT(${PROJECT_NAME} NONE)

if (${CMAKE_VERSION} GREATER_EQUAL "3.27")
     cmake_policy(SET CMP0144 NEW)
endif()

#
# B) Pull in the TriBITS system and execute
#

INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/cmake/tribits/TriBITS.cmake)
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules/")
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${${PROJECT_NAME}_TRIBITS_DIR}/common_tpls/utils)

# Make Trilinos create <Package>Config.cmake files by default
SET(${PROJECT_NAME}_ENABLE_INSTALL_CMAKE_CONFIG_FILES_DEFAULT ON)
# Make Trilinos set up CPack support by default
SET(${PROJECT_NAME}_ENABLE_CPACK_PACKAGING_DEFAULT ON)
# Don't allow disabled subpackages to be excluded from tarball
SET(${PROJECT_NAME}_EXCLUDE_DISABLED_SUBPACKAGES_FROM_DISTRIBUTION_DEFAULT FALSE)

SET(TPL_ENABLE_Pthread OFF CACHE BOOL "")

OPTION(Seacas_ENABLE_DOXYGEN "Enable Doxygen documentation creation." OFF)

# Do all of the processing for this Tribits project
TRIBITS_PROJECT()

=== cmake/tribits/doc/sphinx/requirements.txt ===
Sphinx==8.2.3
sphinx-rtd-theme==3.0.2

=== cmake/tribits/examples/MockTrilinos/CMakeLists.txt ===
# @HEADER
# ************************************************************************
#
#            TriBITS: Tribal Build, Integrate, and Test System
#                    Copyright 2013 Sandia Corporation
#
# Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
# the U.S. Government retains certain rights in this software.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# ************************************************************************
# @HEADER

cmake_minimum_required(VERSION 3.23.0 FATAL_ERROR)
include(${CMAKE_SOURCE_DIR}/ProjectName.cmake)
project(${PROJECT_NAME} NONE)
set(${PROJECT_NAME}_TRIBITS_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../.." CACHE PATH "")
set(${PROJECT_NAME}_TRACE_DEPENDENCY_HANDLING_ONLY ON CACHE BOOL "")
include("${${PROJECT_NAME}_TRIBITS_DIR}/TriBITS.cmake")
tribits_project()

=== cmake/tribits/examples/TargetDefinesPkg/CMakeLists.txt ===
tribits_package(TargetDefinesPkg)

tribits_include_directories(${CMAKE_CURRENT_SOURCE_DIR})

tribits_add_library(
  targetdefinespkg
  HEADERS TargetDefinesPkg.hpp
  SOURCES TargetDefinesPkg.cpp
  )

tribits_add_test_directories(test)

tribits_package_postprocess()

=== packages/seacas/applications/exotec2/CMakeLists.txt ===
TRIBITS_SUBPACKAGE(Exotec2)

TRIBITS_INCLUDE_DIRECTORIES(
  "${CMAKE_CURRENT_SOURCE_DIR}"
)

SET(HEADERS "")
APPEND_GLOB(SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.c)

#disabling on PGI due to an odd compiler issue with the compiler generated assembly.
#this error only seems to manifest on pgi 11.1, however, the version of the compiler
#is not given for pgi compilers unfortunately so we can't be more specific
IF(NOT __LINUX_COMPILER_PGI)
  TRIBITS_ADD_EXECUTABLE(
    exotec2
    NOEXEPREFIX
    NOEXESUFFIX
    SOURCES ${SOURCES}
    COMM serial mpi
    INSTALLABLE
    )
ENDIF()

TRIBITS_SUBPACKAGE_POSTPROCESS()

=== packages/seacas/applications/fastq/CMakeLists.txt ===
INCLUDE(FortranSettings)

TRIBITS_SUBPACKAGE(Fastq)

TRIBITS_INCLUDE_DIRECTORIES(
  "${CMAKE_CURRENT_SOURCE_DIR}"
  )

SET(HEADERS "")

APPEND_GLOB(SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.f ${CMAKE_CURRENT_SOURCE_DIR}/*.F)
list(REMOVE_ITEM SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/fastq.f")

TRIBITS_ADD_LIBRARY(
  fastqlib
  STATIC
  HEADERS ${HEADERS}
  SOURCES ${SOURCES}
  )

TRIBITS_ADD_EXECUTABLE(
  fastq_x11
  NOEXEPREFIX
  NOEXESUFFIX
  LINKER_LANGUAGE Fortran
  SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/fastq.f
	  ${CMAKE_CURRENT_SOURCE_DIR}/cgi/x11_cgisx11.c
  COMM serial mpi
  INSTALLABLE
  )

TRIBITS_ADD_EXECUTABLE(
  fastq_xcps
  NOEXEPREFIX
  NOEXESUFFIX
  LINKER_LANGUAGE Fortran
  SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/fastq.f
	  ${CMAKE_CURRENT_SOURCE_DIR}/cgi/vdx11cps.F
	  ${CMAKE_CURRENT_SOURCE_DIR}/cgi/vdicps_dual.f
  COMM serial mpi
  INSTALLABLE
  )

TRIBITS_ADD_EXECUTABLE(
  fastq_cps
  NOEXEPREFIX
  NOEXESUFFIX
  LINKER_LANGUAGE Fortran
  SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/fastq.f
	  ${CMAKE_CURRENT_SOURCE_DIR}/cgi/vdicps.f
  COMM serial mpi
  INSTALLABLE
  )

SET_PROPERTY(TARGET fastq_x11  PROPERTY POSITION_INDEPENDENT_CODE TRUE)
SET_PROPERTY(TARGET fastq_xcps PROPERTY POSITION_INDEPENDENT_CODE TRUE)
SET_PROPERTY(TARGET fastq_cps  PROPERTY POSITION_INDEPENDENT_CODE TRUE)

TRIBITS_SUBPACKAGE_POSTPROCESS()

=== packages/seacas/libraries/exodus/CMakeLists.txt ===
TRIBITS_SUBPACKAGE(Exodus)

if (SEACASExodus_ENABLE_STATIC)
INCLUDE(InstallSymLink)
endif()

TRIBITS_INCLUDE_DIRECTORIES(
  "${CMAKE_CURRENT_SOURCE_DIR}/include"
)
message("installing shared exodus to: ${CMAKE_INSTALL_LIBDIR}")

FILE(GLOB SOURCES src/ex_*.c)

if (NOT ${PACKAGE_NAME}_HIDE_DEPRECATED_CODE)
  FILE(GLOB DEP_SOURCES src/deprecated/ex_*.c)
endif()
TRIBITS_CONFIGURE_FILE(exodus_config.h)

if (NOT ${EXODUS_THREADSAFE})
   list(REMOVE_ITEM SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/ex_threadsafe.c)
endif()

TRIBITS_SET_AND_INC_DIRS(DIR ${CMAKE_CURRENT_BINARY_DIR})

SET(HEADERS
  include/exodusII.h
  include/exodusII_int.h
  include/exodusII_par.h
  ${CMAKE_CURRENT_BINARY_DIR}/exodus_config.h
)

TRIBITS_ADD_LIBRARY(
  exodus
  HEADERS ${HEADERS}
  SOURCES ${SOURCES} ${DEP_SOURCES}
)

set_property(TARGET exodus PROPERTY C_STANDARD 99)
set_property(TARGET exodus PROPERTY C_EXTENSIONS ON)

if (SEACASExodus_ENABLE_SHARED)
   if (NOT BUILD_SHARED_LIBS)
      ADD_LIBRARY(
              exodus_shared
              SHARED
              ${SOURCES} ${DEP_SOURCES}
      )
      target_include_directories(exodus_shared PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include)
      target_link_libraries(exodus_shared PUBLIC Netcdf::all_libs)
      set_property(TARGET exodus_shared PROPERTY C_STANDARD 99)
      # This keeps the library out of the `all_libs` targets...
      set_target_properties(exodus_shared PROPERTIES TRIBITS_TESTONLY_LIB TRUE)
      set_target_properties(exodus_shared PROPERTIES OUTPUT_NAME exodus)
      message("installing shared exodus to: ${CMAKE_INSTALL_LIBDIR}")
      INSTALL(TARGETS exodus_shared DESTINATION ${CMAKE_INSTALL_LIBDIR})
   endif()
endif()

# Many users of the SEACAS installations still want a static exodus library...
if (SEACASExodus_ENABLE_STATIC)
   # NOTE: If use `TRIBITS_ADD_LIBRARY` here, then both exodus and exodus_static linked to all executables.
   ADD_LIBRARY(
           exodus_static
           STATIC
           ${SOURCES} ${DEP_SOURCES}
   )
   target_include_directories(exodus_static PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include)
   target_link_libraries(exodus_static PUBLIC Netcdf::all_libs)
   set_property(TARGET exodus_static PROPERTY C_STANDARD 99)
   # This keeps the library out of the `all_libs` targets...
   set_target_properties(exodus_static PROPERTIES TRIBITS_TESTONLY_LIB TRUE)
   set_target_properties(exodus_static PROPERTIES OUTPUT_NAME exodus)
   INSTALL(TARGETS exodus_static DESTINATION ${CMAKE_INSTALL_LIBDIR})

   # For backwards compatibility, the C exodus library was called libexoIIv2c.a
   # Create a symbolic link from libexodus.a to libexoIIv2c.a -- do only for static lib
   InstallSymLink(libexodus.a ${CMAKE_INSTALL_PREFIX}/lib/libexoIIv2c.a)
endif()
message("installing shared exodus to: ${CMAKE_INSTALL_LIBDIR}")

if (${CMAKE_PROJECT_NAME} STREQUAL "Seacas")
   # add a target to generate API documentation with Doxygen
   if(Seacas_ENABLE_DOXYGEN)
     find_package(Doxygen)
     if(DOXYGEN_FOUND)
       add_custom_command(TARGET exodus POST_BUILD
          COMMAND ${DOXYGEN_EXECUTABLE} ARGS ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile
          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
          COMMENT "Generating Exodus API documentation with Doxygen" VERBATIM
          )
     endif(DOXYGEN_FOUND)
   endif()
endif()
message("installing shared exodus to: ${CMAKE_INSTALL_LIBDIR}")

TRIBITS_ADD_TEST_DIRECTORIES(test)

TRIBITS_SUBPACKAGE_POSTPROCESS()

=== packages/seacas/libraries/ioss/CMakeLists.txt ===
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)

set(CMAKE_VISIBILITY_INLINES_HIDDEN ON)

TRIBITS_SUBPACKAGE(Ioss)

ADD_SUBDIRECTORY(src)

TRIBITS_SUBPACKAGE_POSTPROCESS()

=== packages/seacas/libraries/chaco/assign/CMakeLists.txt ===
add_sources(chaco
	assign.c assign_out.c mapper.c median.c merge_assign.c rec_median.c rotate.c y2x.c)

=== packages/zoltan/siMPI/pyMPI/siMPI/CMakeLists.txt ===


#
# B) Define the header and source files (and directories)
#

SET(HEADERS "")
SET(SOURCES "")

#
# siMPI/pyMPI/siMPI
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

SET(HEADERS ${HEADERS}
  mpi.h
  mpi_implementation.h
  mpi_prototypes.h
  mpi_profile.h
  mpi_config.h
  _MPI_UTILITY.h
  )

SET(SOURCES ${SOURCES}
  MPI_Comm_create.c
  MPI_Comm_free.c
  MPI_Comm_group.c
  MPI_Comm_rank.c
  MPI_Comm_size.c
  MPI_ERRORS_ARE_FATAL.c
  MPI_ERRORS_RETURN.c
  PMPI_Abort.c
  MPI_Finalize.c
  MPI_Init.c
  PMPI_Comm_create.c
  PMPI_Comm_free.c
  PMPI_Comm_group.c
  PMPI_Comm_rank.c
  PMPI_Comm_size.c
  PMPI_Finalize.c
  PMPI_Init.c
  _MPI_CHECK_STATUS.c
  _MPI_ERR_ROUTINE.c
  PMPI_Send.c
  PMPI_Msend.c
  MPI_Send.c
  _MPI_UTILITY.c
  _MPI_SENDREC_UTIL.c
  _MPI_TYPE_UTIL.c
  _MPI_variables.c
  PMPI_Recv.c
  MPI_Recv.c
  PMPI_Isend.c
  MPI_Isend.c
  PMPI_Irecv.c
  MPI_Irecv.c
  PMPI_Bsend.c
  MPI_Bsend.c
  PMPI_Reduce.c
  MPI_Reduce.c
  PMPI_Bcast.c
  _MPI_BCAST.c
  _MPI_OP_UTIL.c
  PMPI_Op_create.c
  MPI_Op_create.c
  PMPI_Op_free.c
  MPI_Op_free.c
  PMPI_Sendrecv.c
  MPI_Sendrecv.c
  PMPI_Wait.c
  MPI_Wait.c
  _MPI_ABORT.c
  mpi_abort.c
  _MPI_COMM_UTIL.c
  _MPI_REQ_UTIL.c
  PMPI_Ssend.c
  MPI_Ssend.c
  PMPI_Rsend.c
  MPI_Rsend.c
  PMPI_Waitany.c
  PMPI_Scatter.c
  MPI_Scatter.c
  PMPI_Gather.c
  MPI_Gather.c
  PMPI_Issend.c
  MPI_Issend.c
  PMPI_Ibsend.c
  MPI_Ibsend.c
  PMPI_Irsend.c
  MPI_Irsend.c
  MPIO_Test.c
  MPIO_Wait.c
  PMPIO_Test.c
  PMPIO_Wait.c
  MPI_Address.c
  MPI_Allgather.c
  MPI_Allgatherv.c
  MPI_Allreduce.c
  MPI_Alltoall.c
  MPI_Alltoallv.c
  MPI_Attr_delete.c
  MPI_Attr_get.c
  MPI_Attr_put.c
  MPI_Barrier.c
  MPI_Bsend_init.c
  MPI_Buffer_attach.c
  MPI_Buffer_detach.c
  MPI_Cancel.c
  MPI_Cartdim_get.c
  MPI_Errhandler_get.c
  MPI_Info_dup.c
  MPI_Cart_coords.c
  MPI_Cart_create.c
  MPI_Cart_get.c
  MPI_Cart_map.c
  MPI_Cart_rank.c
  MPI_Cart_shift.c
  MPI_Cart_sub.c
  MPI_Comm_compare.c
  MPI_Comm_dup.c
  MPI_Comm_get_name.c
  MPI_Comm_remote_group.c
  MPI_Comm_remote_size.c
  MPI_Comm_set_name.c
  MPI_Comm_split.c
  MPI_Comm_test_inter.c
  PMPI_Address.c
  PMPI_Allgather.c
  PMPI_Allgatherv.c
  PMPI_Allreduce.c
  PMPI_Alltoall.c
  PMPI_Alltoallv.c
  PMPI_Attr_delete.c
  PMPI_Attr_get.c
  PMPI_Attr_put.c
  PMPI_Barrier.c
  PMPI_Bsend_init.c
  PMPI_Buffer_attach.c
  PMPI_Buffer_detach.c
  PMPI_Cartdim_get.c
  PMPI_Errhandler_get.c
  PMPI_Info_dup.c
  PMPI_Cancel.c
  PMPI_Cart_coords.c
  PMPI_Cart_create.c
  PMPI_Cart_get.c
  PMPI_Cart_map.c
  PMPI_Cart_rank.c
  PMPI_Cart_shift.c
  PMPI_Cart_sub.c
  PMPI_Comm_compare.c
  PMPI_Comm_dup.c
  PMPI_Comm_get_name.c
  PMPI_Comm_remote_group.c
  PMPI_Comm_remote_size.c
  PMPI_Comm_set_name.c
  PMPI_Comm_split.c
  PMPI_Comm_test_inter.c
  MPI_File_c2f.c
  MPI_File_close.c
  MPI_File_delete.c
  MPI_File_f2c.c
  MPI_File_get_amode.c
  MPI_File_get_atomicity.c
  MPI_File_get_byte_offset.c
  MPI_File_get_errhandler.c
  MPI_File_get_group.c
  MPI_File_get_info.c
  MPI_File_get_position.c
  MPI_File_get_position_shared.c
  MPI_File_get_size.c
  MPI_File_get_type_extent.c
  MPI_File_get_view.c
  MPI_File_iread.c
  MPI_File_iread_at.c
  MPI_File_iread_shared.c
  MPI_File_iwrite.c
  MPI_File_iwrite_at.c
  MPI_File_iwrite_shared.c
  MPI_File_open.c
  MPI_File_preallocate.c
  MPI_File_read.c
  MPI_File_read_all.c
  MPI_File_read_all_begin.c
  MPI_File_read_all_end.c
  MPI_File_read_at.c
  MPI_File_read_at_all.c
  MPI_File_read_at_all_begin.c
  MPI_File_read_at_all_end.c
  MPI_File_read_ordered.c
  MPI_File_read_ordered_begin.c
  MPI_File_read_ordered_end.c
  MPI_File_read_shared.c
  MPI_File_seek.c
  MPI_File_seek_shared.c
  MPI_File_set_atomicity.c
  MPI_File_set_errhandler.c
  MPI_File_set_info.c
  MPI_File_set_size.c
  MPI_File_set_view.c
  MPI_Dims_create.c
  MPI_Errhandler_create.c
  MPI_Errhandler_free.c
  MPI_Errhandler_set.c
  MPI_Error_class.c
  MPI_Error_string.c
  PMPI_File_c2f.c
  PMPI_File_close.c
  PMPI_File_delete.c
  PMPI_File_f2c.c
  PMPI_File_get_amode.c
  PMPI_File_get_atomicity.c
  PMPI_File_get_byte_offset.c
  PMPI_File_get_errhandler.c
  PMPI_File_get_group.c
  PMPI_File_get_info.c
  PMPI_File_get_position.c
  PMPI_File_get_position_shared.c
  PMPI_File_get_size.c
  PMPI_File_get_type_extent.c
  PMPI_File_get_view.c
  PMPI_File_iread.c
  PMPI_File_iread_at.c
  PMPI_File_iread_shared.c
  PMPI_File_iwrite.c
  PMPI_File_iwrite_at.c
  PMPI_File_iwrite_shared.c
  PMPI_File_open.c
  PMPI_File_preallocate.c
  PMPI_File_read.c
  PMPI_File_read_all.c
  PMPI_File_read_all_begin.c
  PMPI_File_read_all_end.c
  PMPI_File_read_at.c
  PMPI_File_read_at_all.c
  PMPI_File_read_at_all_begin.c
  PMPI_File_read_at_all_end.c
  PMPI_File_read_ordered.c
  PMPI_File_read_ordered_begin.c
  PMPI_File_read_ordered_end.c
  PMPI_File_read_shared.c
  PMPI_File_seek.c
  PMPI_File_seek_shared.c
  PMPI_File_set_atomicity.c
  PMPI_File_set_errhandler.c
  PMPI_File_set_info.c
  PMPI_File_set_size.c
  PMPI_File_set_view.c
  PMPI_Dims_create.c
  PMPI_Errhandler_create.c
  PMPI_Errhandler_free.c
  PMPI_Errhandler_set.c
  PMPI_Error_class.c
  PMPI_Error_string.c
  MPI_File_sync.c
  MPI_File_write.c
  MPI_File_write_all.c
  MPI_File_write_all_begin.c
  MPI_File_write_all_end.c
  MPI_File_write_at.c
  MPI_File_write_at_all.c
  MPI_File_write_at_all_begin.c
  MPI_File_write_at_all_end.c
  MPI_File_write_ordered.c
  MPI_File_write_ordered_begin.c
  MPI_File_write_ordered_end.c
  MPI_File_write_shared.c
  MPI_Finalized.c
  MPI_Gatherv.c
  MPI_Get_count.c
  MPI_Get_elements.c
  MPI_Get_processor_name.c
  MPI_Get_version.c
  MPI_Graph_create.c
  MPI_Graph_get.c
  MPI_Graph_map.c
  MPI_Graph_neighbors.c
  MPI_Graph_neighbors_count.c
  MPI_Graphdims_get.c
  MPI_Group_compare.c
  MPI_Group_difference.c
  MPI_Group_excl.c
  MPI_Group_free.c
  MPI_Group_incl.c
  MPI_Group_intersection.c
  MPI_Group_range_excl.c
  MPI_Group_range_incl.c
  MPI_Group_rank.c
  MPI_Group_size.c
  MPI_Group_translate_ranks.c
  MPI_Group_union.c
  MPI_Info_c2f.c
  MPI_Info_create.c
  MPI_Info_delete.c
  MPI_Info_f2c.c
  MPI_Info_free.c
  MPI_Info_get.c
  MPI_Info_get_nkeys.c
  MPI_Info_get_nthkey.c
  MPI_Info_get_valuelen.c
  MPI_Info_set.c
  MPI_Init_thread.c
  MPI_Initialized.c
  MPI_Int2handle.c
  MPI_Intercomm_create.c
  MPI_Intercomm_merge.c
  MPI_Iprobe.c
  MPI_Keyval_create.c
  MPI_Keyval_free.c
  MPI_Pack.c
  MPI_Pack_size.c
  MPI_Pcontrol.c
  MPI_Probe.c
  MPI_Recv_init.c
  MPI_Reduce_scatter.c
  MPI_Request_c2f.c
  MPI_Request_free.c
  MPI_Rsend_init.c
  MPI_Scan.c
  MPI_Scatterv.c
  MPI_Send_init.c
  MPI_Sendrecv_replace.c
  MPI_Ssend_init.c
  MPI_Start.c
  MPI_Startall.c
  MPI_Status_c2f.c
  MPI_Status_set_cancelled.c
  MPI_Status_set_elements.c
  MPI_Test.c
  MPI_Test_cancelled.c
  MPI_Testall.c
  MPI_Testany.c
  MPI_Testsome.c
  MPI_Topo_test.c
  MPI_Type_commit.c
  MPI_Type_contiguous.c
  MPI_Type_create_darray.c
  MPI_Type_create_indexed_block.c
  MPI_Type_create_subarray.c
  MPI_Type_extent.c
  MPI_Type_free.c
  MPI_Type_get_contents.c
  MPI_Type_get_envelope.c
  MPI_Type_hindexed.c
  MPI_Type_hvector.c
  MPI_Type_indexed.c
  MPI_Type_lb.c
  MPI_Type_size.c
  MPI_Type_struct.c
  MPI_Type_ub.c
  MPI_Type_vector.c
  MPI_Unpack.c
  MPI_Waitsome.c
  MPI_Waitany.c
  MPI_Waitall.c
  PMPI_Waitall.c
  MPI_Wtick.c
  MPI_Wtime.c
  PMPI_File_sync.c
  PMPI_File_write.c
  PMPI_File_write_all.c
  PMPI_File_write_all_begin.c
  PMPI_File_write_all_end.c
  PMPI_File_write_at.c
  PMPI_File_write_at_all.c
  PMPI_File_write_at_all_begin.c
  PMPI_File_write_at_all_end.c
  PMPI_File_write_ordered.c
  PMPI_File_write_ordered_begin.c
  PMPI_File_write_ordered_end.c
  PMPI_File_write_shared.c
  PMPI_Finalized.c
  PMPI_Gatherv.c
  PMPI_Get_count.c
  PMPI_Get_elements.c
  PMPI_Get_processor_name.c
  PMPI_Get_version.c
  PMPI_Graph_create.c
  PMPI_Graph_get.c
  PMPI_Graph_map.c
  PMPI_Graph_neighbors.c
  PMPI_Graph_neighbors_count.c
  PMPI_Graphdims_get.c
  PMPI_Group_compare.c
  PMPI_Group_difference.c
  PMPI_Group_excl.c
  PMPI_Group_free.c
  PMPI_Group_incl.c
  PMPI_Group_intersection.c
  PMPI_Group_range_excl.c
  PMPI_Group_range_incl.c
  PMPI_Group_rank.c
  PMPI_Group_size.c
  PMPI_Group_translate_ranks.c
  PMPI_Group_union.c
  PMPI_Info_c2f.c
  PMPI_Info_create.c
  PMPI_Info_delete.c
  PMPI_Info_f2c.c
  PMPI_Info_free.c
  PMPI_Info_get.c
  PMPI_Info_get_nkeys.c
  PMPI_Info_get_nthkey.c
  PMPI_Info_get_valuelen.c
  PMPI_Info_set.c
  PMPI_Init_thread.c
  PMPI_Initialized.c
  PMPI_Int2handle.c
  PMPI_Intercomm_create.c
  PMPI_Intercomm_merge.c
  PMPI_Iprobe.c
  PMPI_Keyval_create.c
  PMPI_Keyval_free.c
  PMPI_Pack.c
  PMPI_Pack_size.c
  PMPI_Pcontrol.c
  PMPI_Probe.c
  PMPI_Recv_init.c
  PMPI_Reduce_scatter.c
  PMPI_Request_c2f.c
  PMPI_Request_free.c
  PMPI_Rsend_init.c
  PMPI_Scan.c
  PMPI_Scatterv.c
  PMPI_Send_init.c
  PMPI_Sendrecv_replace.c
  PMPI_Ssend_init.c
  PMPI_Start.c
  PMPI_Startall.c
  PMPI_Status_c2f.c
  PMPI_Status_set_cancelled.c
  PMPI_Status_set_elements.c
  PMPI_Test.c
  PMPI_Test_cancelled.c
  PMPI_Testall.c
  PMPI_Testany.c
  PMPI_Testsome.c
  PMPI_Topo_test.c
  PMPI_Type_commit.c
  PMPI_Type_contiguous.c
  PMPI_Type_create_darray.c
  PMPI_Type_create_indexed_block.c
  PMPI_Type_create_subarray.c
  PMPI_Type_extent.c
  PMPI_Type_free.c
  PMPI_Type_get_contents.c
  PMPI_Type_get_envelope.c
  PMPI_Type_hindexed.c
  PMPI_Type_hvector.c
  PMPI_Type_indexed.c
  PMPI_Type_lb.c
  PMPI_Type_size.c
  PMPI_Type_struct.c
  PMPI_Type_ub.c
  PMPI_Type_vector.c
  PMPI_Unpack.c
  PMPI_Waitsome.c
  PMPI_Wtime.c
  PMPI_Wtick.c
  )

#
# C) Define the targets for package's library(s)
#

TRIBITS_ADD_LIBRARY(
  simpi
  HEADERS_INSTALL_SUBDIR simpi
  HEADERS ${HEADERS}
  SOURCES ${SOURCES}
  )

=== packages/seacas/libraries/ioss/src/main/CMakeLists.txt ===
SET(HEADERS "")
SET(SOURCES "")

TRIBITS_SET_AND_INC_DIRS(DIR ${CMAKE_CURRENT_SOURCE_DIR})
APPEND_GLOB(HEADERS ${DIR}/*.h)
APPEND_GLOB(SOURCES ${DIR}/*.C)

TRIBITS_INCLUDE_DIRECTORIES(
  "${CMAKE_CURRENT_SOURCE_DIR}/../"
  "${CMAKE_CURRENT_BINARY_DIR}/../"
)

list(APPEND HEADERS
  "${CMAKE_CURRENT_BINARY_DIR}/io_info_lib_export.h")

TRIBITS_ADD_LIBRARY(
  io_info_lib
  HEADERS io_info.h info_interface.h
  SOURCES io_info.C volume.C info_interface.C
  DEPLIBS Ioss
  )

generate_export_header(io_info_lib)
target_include_directories(io_info_lib
  PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>")

ASSERT_DEFINED(TPL_ENABLE_CGNS)
IF (TPL_ENABLE_CGNS)
TRIBITS_ADD_EXECUTABLE(
  struc_to_unstruc
  NOEXEPREFIX
  NOEXESUFFIX
  SOURCES struc_to_unstruc.C
  INSTALLABLE
  )

TRIBITS_ADD_EXECUTABLE(
  cgns_decomp
  NOEXEPREFIX
  NOEXESUFFIX
  SOURCES cgns_decomp.C
  INSTALLABLE
  )
ENDIF()

TRIBITS_ADD_EXECUTABLE(
  cth_pressure_map
  NOEXEPREFIX
  NOEXESUFFIX
  SOURCES cth_pressure_map.C vector3d.C
  INSTALLABLE
  )
TRIBITS_ADD_EXECUTABLE(
  io_shell
  NOEXEPREFIX
  NOEXESUFFIX
  SOURCES io_shell.C shell_interface.C
  INSTALLABLE
  )
TRIBITS_ADD_EXECUTABLE(
  shell_to_hex
  NOEXEPREFIX
  NOEXESUFFIX
  SOURCES shell_to_hex.C vector3d.C
  INSTALLABLE
  )
TRIBITS_ADD_EXECUTABLE(
  io_info
  NOEXEPREFIX
  NOEXESUFFIX
  SOURCES io_info_main.C
  INSTALLABLE
  )

IF (${PACKAGE_NAME}_ENABLE_SEACASExodus)
TRIBITS_ADD_EXECUTABLE(
  io_modify
  NOEXEPREFIX
  NOEXESUFFIX
  SOURCES io_modify.C modify_interface.C
  INSTALLABLE
  )
endif()

TRIBITS_ADD_EXECUTABLE(
  sphgen
  NOEXEPREFIX
  NOEXESUFFIX
  SOURCES sphgen.C
  INSTALLABLE
  )

TRIBITS_ADD_EXECUTABLE(
  skinner
  NOEXEPREFIX
  NOEXESUFFIX
  SOURCES skinner.C skinner_interface.C
  INSTALLABLE
  )

if (TPL_ENABLE_MPI)
  set(COMPOSE_ARG --compose)
  IF (TPL_Netcdf_PARALLEL)
    set(DECOMP_ARG --rcb)
    set(JOIN_ARG   --compose --netcdf4)
    set(PJOIN_ARG   --compose --netcdf5)
    set(SERIALIZE_ARG "--serialize_io_size=2")
    set(NPROCS 4)
    set(NPROCS_BUG 1)
  else()
    set(COMPOSE_ARG )
    set(SERIALIZE_ARG )
    set(NPROCS 1)
    set(NPROCS_BUG 1)
  endif()
else()
    set(SERIALIZE_ARG )
    set(COMPOSE_ARG )
    set(JOIN_ARG )
    set(PJOIN_ARG )
endif()

if (${CMAKE_PROJECT_NAME}_ENABLE_SEACASExodiff)
if (TPL_Netcdf_Enables_Netcdf4)
TRIBITS_ADD_ADVANCED_TEST(exodus32_to_exodus32
   TEST_0 EXEC io_shell ARGS ${DECOMP_ARG} ${JOIN_ARG} ${CMAKE_CURRENT_SOURCE_DIR}/test/8-block.g 8-block32.g
     NOEXEPREFIX NOEXESUFFIX
     NUM_MPI_PROCS ${NPROCS}
   TEST_1 EXEC exodiff ARGS -pedantic ${CMAKE_CURRENT_SOURCE_DIR}/test/8-block.g 8-block32.g
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
  COMM mpi serial
  XHOSTTYPE Windows
  )

  SET(IOSHELL_ARG --in_type generated 10x10x10+shell:xXyYzZ+times:4+variables:element,2,nodal,3)
  SET(SPLIT_ARG --split_times 1)
  TRIBITS_ADD_ADVANCED_TEST(
    io_shell_group_ungroup
    TEST_0 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS ${SPLIT_ARG} ${IOSHELL_ARG} splits.g
    TEST_1 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS splits.g_1 splits.g_2 splits.g_3 splits.g_4  grouped.g
    TEST_2 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS --extract_group splits.g_1 grouped.g split-extract.g_1
    TEST_3 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS --extract_group splits.g_2 grouped.g split-extract.g_2
    TEST_4 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS --extract_group splits.g_3 grouped.g split-extract.g_3
    TEST_5 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS --extract_group splits.g_4 grouped.g split-extract.g_4
    TEST_6 EXEC exodiff ARGS -pedantic splits.g_1 split-extract.g_1
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    TEST_7 EXEC exodiff ARGS -pedantic splits.g_2 split-extract.g_2
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    TEST_8 EXEC exodiff ARGS -pedantic splits.g_3 split-extract.g_3
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    TEST_9 EXEC exodiff ARGS -pedantic splits.g_4 split-extract.g_4
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    COMM serial
    FINAL_PASS_REGULAR_EXPRESSION
  )

  IF (TPL_Netcdf_PARALLEL)
  TRIBITS_ADD_ADVANCED_TEST(
    io_shell_cs_decompose_compose
    TEST_0 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS ${SPLIT_ARG} ${IOSHELL_ARG} splits_cs.g
       NUM_MPI_PROCS 1
    TEST_1 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS splits_cs.g_1 splits_cs.g_2 splits_cs.g_3 splits_cs.g_4  grouped_cs.g
       NUM_MPI_PROCS 1
    TEST_3 EXEC io_shell ARGS ${DECOMP_ARG} ${JOIN_ARG} grouped_cs.g joined_cs.g
     NOEXEPREFIX NOEXESUFFIX
     NUM_MPI_PROCS ${NPROCS}
    TEST_4 EXEC exodiff ARGS -pedantic grouped_cs.g joined_cs.g
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    COMM mpi serial
    XHOSTTYPE Windows
    FINAL_PASS_REGULAR_EXPRESSION
  )

  TRIBITS_ADD_ADVANCED_TEST(
    io_shell_cs_decompose_epu
    TEST_0 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS ${SPLIT_ARG} ${IOSHELL_ARG} splits_epu.g
       NUM_MPI_PROCS 1
    TEST_1 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS splits_epu.g_1 splits_epu.g_2 splits_epu.g_3 splits_epu.g_4  grouped1_epu.g
       NUM_MPI_PROCS 1
    TEST_3 EXEC io_shell ARGS ${DECOMP_ARG} grouped1_epu.g decomped_epu.g
     NOEXEPREFIX NOEXESUFFIX
     NUM_MPI_PROCS ${NPROCS}
    TEST_4 EXEC epu ARGS -auto decomped_epu.g
       DIRECTORY ../../../../applications/epu
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    TEST_5 EXEC exodiff ARGS -pedantic grouped1_epu.g decomped_epu.g
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    COMM mpi serial
    XHOSTTYPE Windows
    FINAL_PASS_REGULAR_EXPRESSION
  )
endif()

if (${CMAKE_PROJECT_NAME}_ENABLE_SEACASConjoin)
  # Use io_shell to generate several files with each timestep in a separate file
  # Then join those separate files into a single file with each in a separate changeset
  # Then use conjoin to "squash" the changesets into a single "normal" file
  # Compare this file with the same file generated without using changesets...
  TRIBITS_ADD_ADVANCED_TEST(
    io_shell_cs_time_conjoin
    TEST_0 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS ${SPLIT_ARG} ${IOSHELL_ARG} csplits.g
    TEST_1 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS csplits.g_1 csplits.g_2 csplits.g_3 csplits.g_4  changesets.g
    TEST_2 EXEC conjoin  ARGS --output conjoined.g --element_status_variable=NONE --nodal_status_variable=NONE changesets.g 
       DIRECTORY ../../../../applications/conjoin
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    TEST_3 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS ${IOSHELL_ARG} generated.g
    TEST_4 EXEC exodiff ARGS -pedantic conjoined.g generated.g
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    COMM serial
    FINAL_PASS_REGULAR_EXPRESSION
  )

  # Use io_shell to generate multiple files with different geometry, but similar variable names
  # Then join those separate files into a single file with each in a separate changeset
  # Then use conjoin to "squash" the changesets into a single "normal" file
  # Then use conjoin to "squash" the individual files into a single "normal" file
  # Compare the two conjoin outputs...
  SET(GENARG tdelta:0.1+variables:global,1,nodal,2,element,3+bbox:0,0,0,1,1,1)
  TRIBITS_ADD_ADVANCED_TEST(
    io_shell_cs_geometry_conjoin
    TEST_0 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS --in_type generated 1x1x1+times:2+tinit:0.0+${GENARG} single.g
    TEST_1 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS --in_type generated 2x2x2+times:2+tinit:0.3+${GENARG} double.g
    TEST_2 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS --in_type generated 3x3x3+times:2+tinit:0.5+${GENARG} triple.g
    TEST_3 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS --in_type generated 4x4x4+times:2+tinit:0.7+${GENARG} quad.g
    TEST_4 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS single.g double.g triple.g quad.g  geometry.g
    TEST_5 EXEC conjoin  ARGS --output cs_conjoined.g geometry.g 
       DIRECTORY ../../../../applications/conjoin
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    TEST_6 EXEC conjoin  ARGS --output raw_conjoined.g single.g double.g triple.g quad.g
       DIRECTORY ../../../../applications/conjoin
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    TEST_7 EXEC exodiff ARGS -pedantic cs_conjoined.g raw_conjoined.g
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    COMM serial
    FINAL_PASS_REGULAR_EXPRESSION
  )
endif()
endif()

if (TPL_ENABLE_MPI)
  IF (TPL_Netcdf_PARALLEL)
    TRIBITS_ADD_ADVANCED_TEST(exodus_fpp_serialize
       TEST_0 EXEC io_shell ARGS ${DECOMP_ARG} ${SERIALIZE_ARG} ${CMAKE_CURRENT_SOURCE_DIR}/test/8-block.g 8-block32-ser.g
          NOEXEPREFIX NOEXESUFFIX
          NUM_MPI_PROCS ${NPROCS}
       TEST_1 EXEC io_shell ARGS ${JOIN_ARG} ${SERIALIZE_ARG} 8-block32-ser.g 8-block-32-serj.g
          NOEXEPREFIX NOEXESUFFIX
          NUM_MPI_PROCS ${NPROCS}
       TEST_2 EXEC exodiff ARGS -map -stat -pedantic ${CMAKE_CURRENT_SOURCE_DIR}/test/8-block.g 8-block-32-serj.g
          DIRECTORY ../../../../applications/exodiff
          NOEXEPREFIX NOEXESUFFIX
          NUM_MPI_PROCS 1
    COMM mpi
    XHOSTTYPE Windows
    )
  endif()

  TRIBITS_ADD_ADVANCED_TEST(create_path_fpp
     TEST_0 CMND rm ARGS -rf create_path_test_directory
     TEST_1 EXEC io_shell ARGS --in_type generated 100x100x100 create_path_test_directory/1/2/3/4/5/tmp.g
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS ${NPROCS}
     TEST_2 CMND ls ARGS -1 create_path_test_directory/1/2/3/4/5/
     )

  TRIBITS_ADD_ADVANCED_TEST(exodus32_to_exodus64
     TEST_0 EXEC io_shell ARGS -64 ${DECOMP_ARG} ${JOIN_ARG} ${CMAKE_CURRENT_SOURCE_DIR}/test/8-block.g 8-block64.g
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS ${NPROCS}
     TEST_1 EXEC exodiff ARGS -pedantic ${CMAKE_CURRENT_SOURCE_DIR}/test/8-block.g 8-block64.g
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1

    COMM mpi serial
    )

  IF (TPL_Netcdf_Enables_PNetcdf)
  TRIBITS_ADD_ADVANCED_TEST(exodus32_to_exodus32_pnetcdf
     TEST_0 EXEC io_shell ARGS ${DECOMP_ARG} ${PJOIN_ARG} ${CMAKE_CURRENT_SOURCE_DIR}/test/8-block.g 8-block64p.g
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS ${NPROCS}
     TEST_1 EXEC exodiff ARGS -pedantic ${CMAKE_CURRENT_SOURCE_DIR}/test/8-block.g 8-block64p.g
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    COMM mpi serial
    )
  endif()
  ENDIF()
ENDIF()

IF (SEACASIoss_ENABLE_THREADSAFE)
  TRIBITS_ADD_EXECUTABLE(
    io_shell_ts
    NOEXEPREFIX
    NOEXESUFFIX
    SOURCES io_shell_ts.C shell_interface.C
    INSTALLABLE
    )

  if (TPL_ENABLE_MPI)
     SET(IOSHELL_ARG --compose --in_type generated 10x10x10+shell:xXyYzZ+sideset:xXyY+times:2+variables:element,2,nodal,3,sideset,4)
  else()
     SET(IOSHELL_ARG --in_type generated 10x10x10+shell:xXyYzZ+sideset:xXyY+times:2+variables:element,2,nodal,3,sideset,4)
  endif()
  TRIBITS_ADD_ADVANCED_TEST(
    io_shell_ts
    TEST_0 NOEXEPREFIX NOEXESUFFIX EXEC io_shell_ts ARGS ${IOSHELL_ARG} gen-shell-ts.g
    TEST_1 NOEXEPREFIX NOEXESUFFIX EXEC io_shell    ARGS ${IOSHELL_ARG} gen-shell.g
    TEST_2 EXEC exodiff ARGS -pedantic gen-shell-ts.g gen-shell.g
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    COMM mpi serial
    FINAL_PASS_REGULAR_EXPRESSION
  )

  if (TPL_Netcdf_Enables_Netcdf4)
  SET(IOSHELL_ARG --split_times 1 --in_type generated 10x10x10+shell:xXyYzZ+times:4+variables:element,2,nodal,3)
  TRIBITS_ADD_ADVANCED_TEST(
    io_shell_ts_group_ungroup

=== PKGBUILD ===
# Maintainer: Rafał Brzegowy <rafal.brzegowy@yahoo.com>

_realname=seacas
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=2025.03.13
_releases=${pkgver//./-}
pkgrel=2
pkgdesc="The Sandia Engineering Analysis Code Access System (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://gsjaardema.github.io/seacas/"
msys2_repository_url="https://github.com/gsjaardema/seacas"
license=('spdx:BSD-3-Clause')
conflicts=("${MINGW_PACKAGE_PREFIX}-libexodus")
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-fmt"
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread"
         "${MINGW_PACKAGE_PREFIX}-metis"
         "${MINGW_PACKAGE_PREFIX}-matio"
         "${MINGW_PACKAGE_PREFIX}-netcdf")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-python")
source=("https://github.com/gsjaardema/seacas/archive/v${_releases}/${_realname}-${pkgver}.tar.gz"
        "0001-cmake-add-libs.patch"
        "0002-cmake-findHDF5.patch")
sha256sums=('406AFF5B8908D6A3BF6687D825905990101CAA9CF8C1213A508938EED2134D6D'
            'a3561756bfdeb942fc62add0aefa542b0e689b76a7f0d2d357e299465ee344d2'
            '09c4406d57c5ca18b0d2f16161dd6f5e2c5d56f0f73e83bd77272d876569d5cc')
noextract=(${_realname}-${pkgver}.tar.gz)

prepare() {
  plain "Extract ${_realname}-${pkgver}.tar.gz..."
  tar -xzf ${_realname}-${pkgver}.tar.gz || true

  cd "${srcdir}/${_realname}-${_releases}"
  patch -p1 -i "${srcdir}/0001-cmake-add-libs.patch"
  patch -p1 -i "${srcdir}/0002-cmake-findHDF5.patch"
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  #Static Build
  mkdir -p "${_realname}-${_releases}/build-${MSYSTEM}-static" && cd "${_realname}-${_releases}/build-${MSYSTEM}-static"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    INSTALL_PATH=${MINGW_PREFIX} \
    THREADSAFE=ON \
    ../cmake-config \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      ${extra_config[@]} \
      -DCMAKE_C_COMPILER=${MINGW_PREFIX}/bin/${CC}.exe \
      -DCMAKE_CXX_COMPILER=${MINGW_PREFIX}/bin/${CXX}.exe \
      -DPython_EXECUTABLE=${MINGW_PREFIX}/bin/python.exe \
      -DSeacas_ENABLE_Fortran=OFF \
      -DTPL_ENABLE_X11=OFF \
      -DSeacas_ENABLE_TESTS=OFF \
      -DBUILD_SHARED_LIBS=OFF

  ${MINGW_PREFIX}/bin/cmake --build .

  #Shared Build
  mkdir -p "../build-${MSYSTEM}-shared" && cd "../build-${MSYSTEM}-shared"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    INSTALL_PATH=${MINGW_PREFIX} \
    THREADSAFE=ON \
    ../cmake-config \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      ${extra_config[@]} \
      -DCMAKE_C_COMPILER=${MINGW_PREFIX}/bin/${CC}.exe \
      -DCMAKE_CXX_COMPILER=${MINGW_PREFIX}/bin/${CXX}.exe \
      -DPython_EXECUTABLE=${MINGW_PREFIX}/bin/python.exe \
      -DSeacas_ENABLE_Fortran=OFF \
      -DTPL_ENABLE_X11=OFF \
      -DSeacas_ENABLE_TESTS=OFF \
      -DBUILD_SHARED_LIBS=ON

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  #Static Install
  cd "${srcdir}/${_realname}-${_releases}/build-${MSYSTEM}-static"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  #Shared Install
  cd "${srcdir}/${_realname}-${_releases}/build-${MSYSTEM}-shared"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}"/${_realname}-${_releases}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE

  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  for _f in $(find "${pkgdir}"${MINGW_PREFIX}/lib -type f -name '*.cmake'); do
    sed -e "s|${PREFIX_WIN}|\$\{CMAKE_CURRENT_LIST_DIR\}/../../..|g" -i ${_f}
    sed -e "s|${MINGW_PREFIX}|\$\{CMAKE_CURRENT_LIST_DIR\}/../../..|g" -i ${_f}
  done
}
